<?php

namespace Teknisa\MAN\Services;

use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;
use \Setforms2\Shared\ORM\DateTime;

class ParaTipoConsumidorService {
	
	protected $entityManager;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager)  {
		$this->entityManager = $entityManager;
	}
	
	public function findNewConsumidorFilial($params){
	    return $this->entityManager->getConnection()->fetchAll(self::GET_GRUPO_CONSUMIDOR, $params);
	}
	
	public function savePorFilial($params){
	    return $this->entityManager->getConnection()->executeQuery(self::ADD_CONSUMIDOR_FILIAL, $params);
	}
	
	public function removePorFilial($params){
	    return $this->entityManager->getConnection()->executeQuery(self::REMOVE_CONSUMIDOR_FILIAL, $params);
	}
	
	const GET_GRUPO_CONSUMIDOR = "SELECT CDTIPOCONS, NMTIPOCONS, IDREGDUPCATR, IDEMISEXTRSIMPL, IDDESABPESQCON, NRORG  
                                  FROM TIPOCONS
                                  WHERE NMTIPOCONS IN(
                                SELECT NMTIPOCONS
                                FROM TIPOCONS
                                WHERE NMTIPOCONS NOT IN
                                  (
                                    SELECT TI.NMTIPOCONS
                                    FROM
                                      TIPOCONSFILI TF,
                                      TIPOCONS TI
                                    WHERE TF.CDTIPOCONS = TI.CDTIPOCONS
                                    AND TF.CDFILIAL = :CDFILIAL
                                    AND TF.NRORG = :NRORG
                                    AND TF.NRORG = TI.NRORG
                                  )
                                )
                                ORDER BY
                                  CDTIPOCONS
                                ";
                                
  const ADD_CONSUMIDOR_FILIAL = " INSERT INTO TIPOCONSFILI
                                   (CDFILIAL, CDTIPOCONS, DSACESSOSITE, DSPOSMNUSITE, CDTIPOCONSEX,
                                    IDRECEBEBONUS, VRCARGACREDITO, VRBONUSCREDITO, VRSALDCONSBONUS,
                                    IDPERIODOBONUS, CDTIPORECE, QTRECARGASMES)
                                  VALUES  
                                   (:CDFILIAL, :CDTIPOCONS, :DSACESSOSITE, :DSPOSMNUSITE, :CDTIPOCONSEX,
                                    :IDRECEBEBONUS, :VRCARGACREDITO, :VRBONUSCREDITO, :VRSALDCONSBONUS,
                                    :IDPERIODOBONUS, :CDTIPORECE, :QTRECARGASMES)";
                                    
  const REMOVE_CONSUMIDOR_FILIAL = "DELETE FROM TIPOCONSFILI
                                      WHERE CDFILIAL = :CDFILIAL
                                      AND CDTIPOCONS = :CDTIPOCONS
                                      AND NRORG = :NRORG";
}